from datetime import datetime
from hdsr_fewspy.constants.choices import OutputChoices
from hdsr_fewspy.tests.fixtures import fixture_api_efcis_prod_point_biologie_no_download_dir


# silence flake8
fixture_api_efcis_prod_point_biologie_no_download_dir = fixture_api_efcis_prod_point_biologie_no_download_dir


def test_efcis_prod_samples_xml(fixture_api_efcis_prod_point_biologie_no_download_dir):
    """
    <location locationId="20924">
    <shortName>20924 c02 Gemaal Goyerbrug</shortName>
    <lat>51.98814213752072</lat>
    <lon>5.243994665879352</lon>
    <x>145163.0</x>
    <y>444426.0</y>
    </location>
    """
    response = fixture_api_efcis_prod_point_biologie_no_download_dir.get_samples(
        location_id="20924",
        start_time=datetime(2020, 1, 1),
        end_time=datetime(2020, 1, 10),
        output_choice=OutputChoices.xml_response_in_memory,
    )
    assert response.status_code == 200
    assert (
        response.text
        == '<?xml version="1.0" encoding="UTF-8"?>\n<Samples xmlns="http://www.wldelft.nl/fews/PI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.wldelft.nl/fews/PI https://fewsdocs.deltares.nl/schemas/version1.0/pi-schemas/pi_samples.xsd" version="1.25" xmlns:fs="http://www.wldelft.nl/fews/fs" xmlns:qualifierId="http://www.wldelft.nl/fews/qualifierId">\n    <timeZone>0.0</timeZone>\n    <sample id="2020_00090e">\n        <header>\n            <moduleInstanceId>Import_EFCIS_dump</moduleInstanceId>\n            <locationId>20924</locationId>\n            <sampleDate date="2020-01-09" time="09:57:00"/>\n            <lat>51.98814213752072</lat>\n            <lon>5.243994665879352</lon>\n            <x>145163.0</x>\n            <y>444426.0</y>\n        </header>\n        <properties>\n            <string key="activiteit" value="Automatische FTP import"/>\n            <string key="namespace" value="NL14"/>\n        </properties>\n        <table>\n            <row parameterId="WNS1042" qualifierId:q1="WNS1042" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1569" flag="0" value="0.71" unit="mg/l"/>\n            <row parameterId="WNS1078" qualifierId:q1="WNS1078" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1582" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS1085" qualifierId:q1="WNS1085" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1584" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS1230" qualifierId:q1="WNS1230" qualifierId:q2="GH_16" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1721" flag="0" value="0" unit="DIMSLS"/>\n            <row parameterId="WNS1316" qualifierId:q1="WNS1316" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1819" flag="0" value="9.2" unit="mg/l"/>\n            <row parameterId="WNS1317" qualifierId:q1="WNS1317" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1819" flag="0" value="8.6" unit="mg/l"/>\n            <row parameterId="WNS1381" qualifierId:q1="WNS1381" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1898" flag="0" value="33" unit="mg/l"/>\n            <row parameterId="WNS1387" qualifierId:q1="WNS1387" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1928" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS1413" qualifierId:q1="WNS1413" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1946" flag="0" value="0.88" unit="ug/l"/>\n            <row parameterId="WNS1436" qualifierId:q1="WNS1436" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1958" flag="0" value="10.6" unit="mg/l"/>\n            <row parameterId="WNS1588" qualifierId:q1="WNS1588" qualifierId:q2="GH_260" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" flag="0" value="7.9" unit="DIMSLS"/>\n            <row parameterId="WNS1632" qualifierId:q1="WNS1632" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2334" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS1747" qualifierId:q1="WNS1747" qualifierId:q2="GH_34" qualifierId:q3="HH_498" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_3972" flag="0" value="2.87" unit="mg/l"/>\n            <row parameterId="WNS1810" qualifierId:q1="WNS1810" qualifierId:q2="GH_8" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2366" flag="0" value="0" unit="DIMSLS"/>\n            <row parameterId="WNS1923" qualifierId:q1="WNS1923" qualifierId:q2="GH_193" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" flag="0" value="9.2" unit="oC"/>\n            <row parameterId="WNS2180" qualifierId:q1="WNS2180" qualifierId:q2="GH_8" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2629" flag="0" value="0" unit="DIMSLS"/>\n            <row parameterId="WNS2207" qualifierId:q1="WNS2207" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2647" flag="0" value="4" unit="ug/l"/>\n            <row parameterId="WNS2241" qualifierId:q1="WNS2241" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_822" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS2301" qualifierId:q1="WNS2301" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1580" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS2305" qualifierId:q1="WNS2305" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1646" flag="0" value="160" unit="mg/l"/>\n            <row parameterId="WNS2315" qualifierId:q1="WNS2315" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1707" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS2323" qualifierId:q1="WNS2323" qualifierId:q2="GH_34" qualifierId:q3="HH_483" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1861" flag="0" value="0.1" unit="mg/l"/>\n            <row parameterId="WNS2333" qualifierId:q1="WNS2333" qualifierId:q2="GH_34" qualifierId:q3="HH_483" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1956" flag="0" value="2.9" unit="mg/l"/>\n            <row parameterId="WNS2337" qualifierId:q1="WNS2337" qualifierId:q2="GH_34" qualifierId:q3="HH_498" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1857" flag="0" value="0.0922" unit="mg/l"/>\n            <row parameterId="WNS2352" qualifierId:q1="WNS2352" qualifierId:q2="GH_235" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1958" flag="0" value="91" unit="%"/>\n            <row parameterId="WNS2354" qualifierId:q1="WNS2354" qualifierId:q2="GH_34" qualifierId:q3="HH_518" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2328" flag="0" value="0.095" unit="mg/l"/>\n            <row parameterId="WNS2390" qualifierId:q1="WNS2390" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_3976" flag="0" value="0.1" unit="ug/l"/>\n            <row parameterId="WNS2440" qualifierId:q1="WNS2440" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1962" flag="0" value="16" unit="mg/l"/>\n            <row parameterId="WNS2526" qualifierId:q1="WNS2526" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_3977" flag="0" value="0.17" unit="ug/l"/>\n            <row parameterId="WNS2718" qualifierId:q1="WNS2718" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1715" flag="0" value="3.6" unit="mg/l"/>\n            <row parameterId="WNS2745" qualifierId:q1="WNS2745" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1898" flag="0" value="35" unit="mg/l"/>\n            <row parameterId="WNS2752" qualifierId:q1="WNS2752" qualifierId:q2="GH_34" qualifierId:q3="HH_498" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1877" flag="0" value="0.0143" unit="mg/l"/>\n            <row parameterId="WNS2753" qualifierId:q1="WNS2753" qualifierId:q2="GH_34" qualifierId:q3="HH_498" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1882" flag="0" value="2.86" unit="mg/l"/>\n            <row parameterId="WNS2754" qualifierId:q1="WNS2754" qualifierId:q2="GH_34" qualifierId:q3="HH_138" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1238" flag="0" value="2.53" unit="mg/l"/>\n            <row parameterId="WNS2757" qualifierId:q1="WNS2757" qualifierId:q2="GH_8" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1961" flag="0" value="0" unit="DIMSLS"/>\n            <row parameterId="WNS2786" qualifierId:q1="WNS2786" qualifierId:q2="GH_34" qualifierId:q3="HH_533" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2291" flag="0" value="0.0529" unit="mg/l"/>\n            <row parameterId="WNS2981" qualifierId:q1="WNS2981" qualifierId:q2="GH_16" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1595" flag="0" value="0" unit="DIMSLS"/>\n            <row parameterId="WNS3875" qualifierId:q1="WNS3875" qualifierId:q2="TP_172" qualifierId:q3="HH_492" qualifierId:q4="ACO_31" qualifierId:q5="MCO_31" flag="0" value="101" unit="-"/>\n            <row parameterId="WNS3882" qualifierId:q1="WNS3882" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1174" flag="0" value="75.9" unit="mg/l"/>\n            <row parameterId="WNS3884" qualifierId:q1="WNS3884" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_2376" flag="0" value="40.2" unit="mg/l"/>\n            <row parameterId="WNS399" qualifierId:q1="WNS399" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_807" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS405" qualifierId:q1="WNS405" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_808" flag="0" value="0.02" unit="ug/l"/>\n            <row parameterId="WNS474" qualifierId:q1="WNS474" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_828" flag="0" value="1" unit="ug/l"/>\n            <row parameterId="WNS476" qualifierId:q1="WNS476" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_828" flag="0" value="1" unit="ug/l"/>\n            <row parameterId="WNS503" qualifierId:q1="WNS503" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_883" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS513" qualifierId:q1="WNS513" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_885" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS5150" qualifierId:q1="WNS5150" qualifierId:q2="GH_80" qualifierId:q3="HH_127" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" flag="0" value="220" unit="mg/l"/>\n            <row parameterId="WNS520" qualifierId:q1="WNS520" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_886" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS576" qualifierId:q1="WNS576" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_897" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS591" qualifierId:q1="WNS591" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_907" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS617" qualifierId:q1="WNS617" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1154" flag="0" value="69" unit="mg/l"/>\n            <row parameterId="WNS618" qualifierId:q1="WNS618" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1154" flag="0" value="66" unit="mg/l"/>\n            <row parameterId="WNS6708" qualifierId:q1="WNS6708" qualifierId:q2="GH_34" qualifierId:q3="HH_498" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1856" flag="0" value="0.0011" unit="mg/l"/>\n            <row parameterId="WNS673" qualifierId:q1="WNS673" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1173" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS7128" qualifierId:q1="WNS7128" qualifierId:q2="GH_69" qualifierId:q3="HH_12" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" flag="0" value="600" unit="uS/cm"/>\n            <row parameterId="WNS716" qualifierId:q1="WNS716" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1239" flag="0" value="0.5" unit="ug/l"/>\n            <row parameterId="WNS7384" qualifierId:q1="WNS7384" qualifierId:q2="GH_257" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" flag="0" value="0.5" unit="m"/>\n            <row parameterId="WNS740" qualifierId:q1="WNS740" qualifierId:q2="GH_34" qualifierId:q3="HH_608" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1248" flag="0" value="1.1" unit="ug/l"/>\n            <row parameterId="WNS742" qualifierId:q1="WNS742" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1248" flag="0" value="3" unit="ug/l"/>\n            <row parameterId="WNS814" qualifierId:q1="WNS814" qualifierId:q2="GH_34" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1257" flag="0" value="0.01" unit="ug/l"/>\n            <row parameterId="WNS8372" qualifierId:q1="WNS8372" qualifierId:q2="GH_20" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" qualifierId:q6="PC_1725" flag="0" value="5" unit="%"/>\n            <row parameterId="WNS9756" qualifierId:q1="WNS9756" qualifierId:q2="GH_191" qualifierId:q3="HH_492" qualifierId:q4="ACO_39" qualifierId:q5="MCO_39" flag="0" value="100" unit="-"/>\n        </table>\n    </sample>\n</Samples>'  # noqa
    )
